=== android/service/CMakeLists.txt ===
add_subdirectory(engine)
#add_subdirectory(engine_test)
