=== debian/changelog ===
opencv (2.4.2+dfsg-0exp2ubuntu1) raring; urgency=low

  * Added debian/patches/fix-flann-gcc-c++11-bug.patch:
     - Backport from upstream, commit 3df72fe669d27893fae2cffa6287ad8abdcac84f
     - Fixes build issues when using gcc and C++11

 -- Adrien Cunin <adri2000@ubuntu.com>  Thu, 06 Dec 2012 21:06:56 +0100

opencv (2.4.2+dfsg-0exp2) experimental; urgency=low

  * Update debian/control.
    - Dump cmake version to 2.8.7.
      When old cmake is used, building failed.
  * Update libopencv-core-dev.install.
    - Add opencv2/opencv_modules.hpp.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 24 Jul 2012 12:22:11 +0900

opencv (2.4.2+dfsg-0exp1) experimental; urgency=low

  * New upstream release.
  * Update debian/control.
    - Changed Depends from libtiff4-dev to libtiff-dev. (Closes: #682238)
    - Support eigen2. Add libeigen2-dev to Build-Depends.
  * Update install file.
    Change path of samples and add python2.
  * Update debian/rules.
    - Remove chmod line. Removed build_all.sh.
    - Add -r for option of rm command.
  * Update patches/build-static-libs.patch

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 16 Jul 2012 04:03:56 +0900

opencv (2.4.1+dfsg-0exp2) experimental; urgency=low

  * Update package description.
  * Add patches/pkg-config.patch.
    This changed library specification method in pkgconfig.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 26 Jun 2012 16:19:21 +0900

opencv (2.4.1+dfsg-0exp1) experimental; urgency=low

  * New upstream release.
  * Update debian/rules.
    - Enable hardening option.
  * Update debian/control.
    - Fix wrong package name.
    - Add python-numpy-abi9 and python-numpy (>= 1:1.6.1) to python-opencv.
      Fix lintian error for missing-dependency-on-numpy-abi.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 07 Jun 2012 08:54:31 +0900

opencv (2.4.0+dfsg-0exp1) experimental; urgency=low

  * New upstream release. (Closes: 671377)
    - Add stitching, ts, videostab and photo packages.
    - Remove gpu package.
  * Update debian/control.
    - Bumped Standards-Version to 3.9.3. No changes needed.
    - Update Homepage field.
  * Update debian/rules.
    - Remove unnecessary option of build config.
  * Update patches.
    - 0005-build-static-libs.patch
    - 0007-typos-in-strings-docs.patch
    - 0013_drop_asm_types_h_kfreebsd.patch
	
 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 23 May 2012 12:42:17 +0900

opencv (2.3.1-10) unstable; urgency=high

  * Update debian/control.
    - Add Replaces and Breaks of libopencv-core-dev to libopencv-dev.
      (Closes: #674242)
    - Cleanup Depends of packages.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 29 May 2012 08:43:39 +0900

opencv (2.3.1-9) unstable; urgency=low

  * Update debian/control.
    - pkg-config and binarys move from libopencv-core-dev to libopencv-dev.
	  (Closes: #671376, #658197)
    - Drop Replaces and Breaks from libopencv-core-dev. (Closes: #668708)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 22 May 2012 12:17:09 +0900

opencv (2.3.1-8) unstable; urgency=low

  * Add support TBB.
  * Fix getting value of dpkg-architecture.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 02 Feb 2012 12:40:01 +0900
